Imports System.IO
Public Class Form1

    Dim fsw As FileSystemWatcher

    Private Sub bnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnQuit.Click
        Me.Close()
    End Sub

    Private Sub bnDirBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnDirBrowse.Click
        If FolderBrowserDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbDirectory.Text = FolderBrowserDialog1.SelectedPath
        End If
    End Sub

    Private Sub bnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnStart.Click
        fsw = New System.IO.FileSystemWatcher

        ' set a file filter (like "*.txt")
        fsw.Filter = tbFilter.Text

        ' this is just a demo, so let's not include subdirectories
        fsw.IncludeSubdirectories = False

        ' let's set up the watcher to catch a list of changes
        fsw.NotifyFilter = (NotifyFilters.Size Or NotifyFilters.FileName Or NotifyFilters.DirectoryName)

        ' the path of the directory to watch
        fsw.Path = tbDirectory.Text

        ' Add event handlers.
        AddHandler fsw.Changed, AddressOf fwsChanged
        AddHandler fsw.Created, AddressOf fwsChanged
        AddHandler fsw.Deleted, AddressOf fwsChanged
        AddHandler fsw.Renamed, AddressOf fwsRenamed

        ' Let's go!
        fsw.EnableRaisingEvents = True

        tbMessages.Text &= "Started: " & Now & vbCrLf
    End Sub

    Private Sub bnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnStop.Click
        ' discontinue watching
        fsw.EnableRaisingEvents = False
        tbMessages.Text &= "Stopped: " & Now & vbCrLf
    End Sub

    ' The "event handler" for the Changed, Created, and Deleted events
    ' This much match an "implied" delegate
    ' Delegate Sub FileSystemEventHandler(sender as Object, e as System.IO.FileSystemEventArgs)
    Private Sub fwsChanged(ByVal source As Object, ByVal e As FileSystemEventArgs)
        ' write to the message window
        tbMessages.Text &= "File '" & e.Name & "' " & [Enum].GetName(GetType(WatcherChangeTypes), e.ChangeType) & vbCrLf
        Application.DoEvents()
    End Sub

    ' Event Handler for the Renamed event
    ' Delegate Sub RenamedEventHandler(sender as Object, e as System.IO.RenamedEventArgs)
    Private Sub fwsRenamed(ByVal source As Object, ByVal e As RenamedEventArgs)
        tbMessages.Text &= "File '" & e.Name & "' " & [Enum].GetName(GetType(WatcherChangeTypes), e.ChangeType) & vbCrLf
        Application.DoEvents()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' this is required because the event handlers are running in a different
        ' thread as the Form.
        [Form].CheckForIllegalCrossThreadCalls = False
    End Sub
End Class
